; 

.include "m128def.inc"
 ; 
.def scancode=r16
.def schscan=r17
.def schopr=r18
.def code=r19
.def keycode=r20
.def temp=r21
.def frec=r22
.def dlit=r23
.def zader=r24
.def zader1=r25

; 
;  
.ORG $0         ;  
reset:
rjmp  Start          ;   Start  
.ORG $20         ;     T0
rjmp IntT0
.ORG $22           ;   pp

Start:     	ldi temp,$FF   ; 
          	out SPL,temp
		  	ldi temp,$10   ; 
         	out SPH,temp
			ldi	dlit,	1
          	rcall Scan              ;    
Frec_:     	out TCNT0,frec       ;   
          	ldi temp,$03            ;  T0, fck/64
          	out TCCR0,temp
			out OCR1AL,dlit        ;   
        	ldi temp,$01      ;  T1, PWM 8  81
       		out TCCR1A,temp
       		ldi temp,$01       ; p T1, fck/1
       		out TCCR1B,temp
        	ldi temp,$02       ;    0
        	out TIMSK,temp
			ldi temp,$03            ;  PB0  PB1                                               ;
       		out DDRB,temp          
       		sei                 ;  pp
Work:     	rjmp  Work             ;  pp,   


; c 
Scan:    	clr scancode      ; scancode
           	ldi temp,$0F 		; 4-   D  
           	out ddrd,temp              ; 4-   
			ldi temp,$F0 				;
           	out portd,temp              ;
Stklav:    	sec                       ;  
          	ldi temp,$01                ; . S1  1
          	ldi schscan,$04      ;  
          	ldi code,$FE   		;   
Schs:      	out portd,code      ;     D
          	rol code                   ;  
          	in keycode,pind            ;  
          	swap keycode      ;  4-   
          	ldi schopr,$03               ;  
Scho:       ror keycode             ;  
			brcc Oprkl        ;        ;.
If0:        inc temp                       ; scancode
           	dec schopr                    ;  
           	brne Scho                 ; schopr=0,     Sho
            dec schscan           ;  
           	brne Schs                  ; schscan=0,     Shs
            rjmp Stklav               ;    Klav

Oprkl:      cpi temp,$0C      ;   . ""
        	breq Delay ;     
			mov scancode,temp         ;    .   ;scancode
            rjmp If0                ;   

;    
;  10    
Delay:      clr zader
            ldi zader1,$96
Delay1:  	dec zader
            brne Delay1
            dec zader1
           	brne Delay1

;     
 Setkl:    	cpi scancode,$0       ;   . "", 
            breq If0                ;           
            cpi scancode,$1
            ldi frec,$D9          ;   800 
            ldi dlit,$18      ;   - 12 
            breq Endkl
          	cpi scancode,$2
          	ldi frec,$ED         ;   1600 
          	ldi dlit,$30       ;   - 24 
          	breq Endkl
          	cpi scancode,$3
          	ldi frec,$F3         ;   2400 
          	ldi dlit,$48       ;   - 36 
          	breq Endkl
          	cpi scancode,$4
          	ldi frec,$F7         ;   3200 
          	ldi dlit,$60     ;   - 48 
          	breq Endkl
          	cpi scancode,$5
          	ldi frec,$F9         ;   4000 
          	ldi dlit,$78       ;   - 60 
          	breq Endkl
          	cpi scancode,$6
          	ldi frec,$FA          ;   4800 
          	ldi dlit,$90       ;   - 72 
          	breq Endkl
          	cpi scancode,$7
          	ldi frec,$FB           ;   5600 
          	ldi dlit,$A8        ;   - 84 
          	breq Endkl
          	cpi scancode,$8
          	ldi frec,$FC           ;   6400 
          	ldi dlit,$C0       ;   - 96 
          	breq Endkl
          	cpi scancode,$9
         	ldi frec,$FD           ;   7200 
         	ldi dlit,$D8      ;   - 108 
        	breq Endkl
       		ldi frec,$FE           ;   8000 
          	ldi dlit,$F0     ;   - 120 
Endkl:      ret

;pp pp  p p T0
IntT0:   	push temp           ; temp  
      		out TCNT0,frec   ;pp  0
      		in temp,SREG   ; SREG
            sbis pinb,0       ;  PB0  "0",   "1"
           	rjmp Ust1        ; 
      		cbi portb,0
      		rjmp EndT0
Ust1:   	sbi portb,0
EndT0:   	out SREG,temp     ; SREG
      		pop temp             ;   
      		reti                     ;  

 
